<template>
  <main class="main">
    <div class="main__container __container">
      <h1 class="main-title">Персональные данные</h1>
      <form class="form">
        <label class="form__input w-100">
          <input type="text" v-model.trim="Person.name" />
          <span>Имя</span>
        </label>
        <label class="form__input w-100">
          <input type="number" v-model.trim="Person.age" />
          <span>Возраст</span>
        </label>
        <div class="child-add-nav">
          <div class="child-add-nav__title">Дети (макс. 5)</div>
          <button class="child-add-nav__button button button_b button_w-i" v-if="childsLength" @click.prevent="addChild()">
            <span>
              <svg width="24" height="24" viewBox="0 0 24 24" fill="none" xmlns="http://www.w3.org/2000/svg">
                <path
                  fill-rule="evenodd"
                  clip-rule="evenodd"
                  d="M5.13332 10.8556C4.50125 10.8555 3.98887 11.3679 3.98887 12C3.98887 12.6321 4.50126 13.1445 5.13332 13.1445L10.8554 13.1445L10.8554 18.8668C10.8554 19.4989 11.3678 20.0113 11.9999 20.0113C12.632 20.0113 13.1444 19.4989 13.1444 18.8668L13.1443 13.1445L18.8667 13.1445C19.4988 13.1445 20.0112 12.6321 20.0112 12C20.0112 11.3679 19.4988 10.8556 18.8667 10.8556L13.1443 10.8556L13.1443 5.13338C13.1443 4.50132 12.632 3.98893 11.9999 3.98893C11.3678 3.98893 10.8554 4.50131 10.8554 5.13338L10.8554 10.8556L5.13332 10.8556Z"
                  fill="currentColor"
                />
              </svg>
            </span>
            <p>Добавить ребенка</p>
          </button>
        </div>
        <div class="childs-info-form">
          <div class="childs-info-form__item" v-for="child in Person.childs" :key="child.id">
            <label class="childs-info-form__input form__input">
              <input type="text" v-model.trim="child.name" />
              <span>Имя</span>
            </label>
            <label class="childs-info-form__input form__input">
              <input type="number" v-model.trim="child.age" />
              <span>Возраст</span>
            </label>
            <button class="childs-info-form__button button" @click.prevent="removeChild(child.id)">Удалить</button>
          </div>

          <button class="childs-info-form__save button button_primary" @click.prevent="saveForm()">Сохранить</button>
        </div>
      </form>
    </div>
  </main>
</template>

<script>
  import { mapMutations } from 'vuex'
  export default {
    name: 'FormCreate',
    data() {
      return {
        Person: {
          name: '',
          age: '',
          childs: [{ id: 0, name: '', age: '' }]
        }
      }
    },
    computed: {
      childsLength() {
        return this.Person.childs.length < 5
      }
    },
    methods: {
      ...mapMutations({ setPerson: 'person/setPerson' }),
      addChild() {
        const childsLength = this.Person.childs.length
        if (this.childsLength) {
          const child = { id: childsLength, name: '', age: '' }
          this.Person.childs.push(child)
        }
      },
      removeChild(id) {
        this.Person.childs = this.Person.childs.filter((child) => child.id != id)
      },
      saveForm() {
        this.filterChilds()
        this.setPerson(this.Person)
        const cleanPerson = { name: '', age: '', childs: [{ id: 0, name: '', age: '' }] }
        this.Person = cleanPerson
      },
      filterChilds() {
        this.Person.childs = this.Person.childs.filter((child) => child.name || child.age)
      }
    }
  }
</script>

<style lang="scss" scoped>
  .form {
    &__input {
      border: 1px solid var(--gray);
      border-radius: 4px;
      padding: 6px 16px;
      display: block;
      margin-bottom: 10px;
      display: flex;
      flex-direction: column-reverse;
      span {
        display: block;
        font-style: normal;
        font-weight: 400;
        font-size: 14px;
        line-height: 24px;
        color: rgba(17, 17, 17, 0.48);
        transition: 0.3s;
        font-size: 13px;
        line-height: 16px;
        padding-bottom: 2px;
      }
      input {
        display: block;
        font-style: normal;
        font-weight: 400;
        font-size: 14px;
        line-height: 24px;
        color: var(--black);
        width: 100%;
        -moz-appearance: textfield;
        &::-webkit-outer-spin-button,
        &::-webkit-inner-spin-button {
          -webkit-appearance: none;
          margin: 0;
        }
      }
    }
  }

  .child-add-nav {
    display: flex;
    align-items: center;
    justify-content: space-between;
    margin-top: 33px;
    &__title {
      font-style: normal;
      font-weight: 500;
      font-size: 16px;
      line-height: 24px;
      display: flex;
      align-items: center;
      color: var(--black);
    }

    &__button {
    }
  }
  .button {
    background-color: transparent;
    font-style: normal;
    font-weight: 400;
    font-size: 14px;
    line-height: 24px;
    color: var(--primary);
    padding: 10px 20px;
    display: flex;
    align-items: center;
    transition: 0.2s;
    span {
      display: block;
      width: 24px;
      height: 24px;
      margin-right: 4px;
    }
    &_b {
    }

    &_w-i {
      border: 2px solid var(--primary);
      box-sizing: border-box;
      border-radius: 100px;
      &:hover,
      &:focus {
        background-color: var(--primary);
        color: var(--white);
      }
    }

    &_primary {
      border-radius: 100px;
      background-color: var(--primary);
      color: var(--white);
    }
  }
  .childs-info-form {
    margin-top: 10px;
    &__item {
      display: flex;
    }

    &__input {
      margin-right: 18px;
      flex: 1 1 auto;
    }

    &__button {
      padding-left: 0;
      padding-right: 0;
    }

    &__save {
      margin-top: 30px;
    }
  }
</style>
